package com.jianshui.api.config;

import cn.hutool.core.util.XmlUtil;
import org.w3c.dom.*;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;
import java.util.Set;

/**
 * @Description
 * @Author 巩权林
 * @Date 2023/3/10 15:43
 **/
public class WebserviceResponseHandler implements SOAPHandler<SOAPMessageContext> {
    @Override
    public Set<QName> getHeaders() {
        return null;
    }

    @Override
    public boolean handleMessage(SOAPMessageContext context) {
        SOAPMessage message = context.getMessage();
        Boolean outbound = (Boolean) context.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
        if (outbound) {
            // 处理传出的SOAP消息
            try {
                SOAPBody body = message.getSOAPBody();
                Node returnNode = body.getFirstChild().getFirstChild();
                Node dataNode = returnNode.getFirstChild();


//                body.getFirstChild().getOwnerDocument().setTextContent(XmlUtil.toStr(dataNode));
//                body.removeChild(dataNode);

//                addCDataToLeafNodes(dataNode);

//                String aa = XmlUtil.toStr(dataNode,"GBK",false,false);
//                returnNode.replaceChild(XmlUtil.parseXml(aa),dataNode);

//                String cdatameg = "<![CDATA["+ XmlUtil.toStr(returnNode.getFirstChild(),"GBK",false,false) +"]]>";
               /* String cdatameg = XmlUtil.toStr(returnNode.getFirstChild(), "GBK", false, false);
//                CDATASection cdata = childNode.getOwnerDocument().createCDATASection(cdatameg);
                cdatameg = cdatameg.replaceAll("&amp;gt;", ">").replaceAll("&lt;", "<").replaceAll("&gt;", ">");

                String modifiedContent = cdatameg.replace("]]>", "]] >>");
                Element element = body.getOwnerDocument().createElement("return");

                CDATASection cdata = body.getFirstChild().getFirstChild().getOwnerDocument().createCDATASection(modifiedContent);
                element.appendChild(cdata);

                body.removeContents();
                body.appendChild(element);

                body.getOwnerDocument().getOwnerDocument().getTextContent().replaceAll("]] >>", "]]>");*/
//                returnNode.removeChild(dataNode);
//                returnNode.getParentNode().appendChild(element);


               /* System.out.println(cdatameg);
                returnNode.setTextContent(cdatameg);

                String modifiedContent = cdatameg.replace("]]>", "]] >");
                Element element = body.getFirstChild().getFirstChild().getOwnerDocument().createElement("AAD");
                CDATASection cdata = body.getFirstChild().getFirstChild().getOwnerDocument().createCDATASection(modifiedContent);
                element.appendChild(cdata);
                body.appendChild(element);*/
//
//
//                String returnNodeStr = XmlUtil.toStr(returnNode).replaceAll("]]>","]]]]><![CDATA[");
//                System.out.println(returnNodeStr);
//
//                body.getFirstChild().replaceChild(XmlUtil.parseXml(returnNodeStr),returnNode);

               /* System.out.println("1=>" + returnNode.getNodeName() + returnNode.getNodeValue());
                System.out.println("1=>" + body.getFirstChild());

                CDATASection cdataSection = returnNode.getOwnerDocument().createCDATASection( returnNode.getTextContent() );
                returnNode.replaceChild(cdataSection, dataNode);
                System.out.println("2=>" + returnNode);*/


                message.saveChanges();


                // 修改CDATA标签位置
//                addCDataToLeafNodes(dataNode);

//                CDATASection cdata = dataNode.getOwnerDocument().createCDATASection(XmlUtil.toStr(dataNode,"GBK",false,false));
//                returnNode.removeChild(dataNode);
//                returnNode.appendChild(cdata);

//                addCDataToLeafNodes(cdata);

//                CDATASection cdata = dataNode.getOwnerDocument().createCDATASection(XmlUtil.toStr(dataNode,"GBK",false,false));
//                returnNode.removeChild(dataNode);
//                returnNode.appendChild(cdata);

                // TODO: 2023/7/12
//                addCDataToLeafNodes(dataNode);


//                String nodeStr = XmlUtil.toStr(returnNode.getFirstChild(), "GBK", false, false)
//                        .replaceAll("&lt;","<").replaceAll("&gt;",">");
//                nodeStr = "<![CDATA[" + nodeStr + "]]>";

//                dataNode.setTextContent(nodeStr);
//                returnNode.replaceChild(dataNode,XmlUtil.parseXml(nodeStr));
//                System.out.println(nodeStr);
                // 将处理后的XML重新设到SOAP消息中
//                System.out.println(nodeStr);


                // body.getFirstChild().removeChild(body.getFirstChild().getFirstChild());
                // CDATASection cdata = Data.getOwnerDocument().createCDATASection(XmlUtil.toStr(fp, "GBK", false, true));
                // body.setTextContent(XmlUtil.toStr(body.getFirstChild()));

            }catch (Exception e) {
                throw new RuntimeException(e);
            }
        } else {
            // 处理传入的SOAP消息
        }
        return true;
    }

 /*   public String convertDocumentToString(Document document) throws Exception {
        TransformerFactory transformerFactory = TransformerFactory.newInstance();
        Transformer transformer = transformerFactory.newTransformer();
        transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");  // 忽略 XML 声明
        transformer.setOutputProperty(OutputKeys.INDENT, "yes");  // 格式化输出
        transformer.setOutputProperty(OutputKeys.CDATA_SECTION_ELEMENTS, "*");  // 适用于所有元素的 CDATA

        DOMSource source = new DOMSource(document);
        StreamResult result = new StreamResult(new StringWriter());
        transformer.transform(source, result);
        return result.getWriter().toString();
    }*/

    /**
     * @Author: kk
     * @Description: CDATA类
     * @DateTime: 2023/6/5 19:12
     * @Params:
     * @Return
     */
    public static void addCDataToLeafNodes(Node returnNode) {

        /*NodeList childNodes = returnNode.getChildNodes();


        for (int i = 0; i < childNodes.getLength(); i++) {
            Node childNode = childNodes.item(i);
            Node firstChild = childNode.getFirstChild();
            if (firstChild != null && childNode.getNodeType() == Node.ELEMENT_NODE) {
                addCDataToLeafNodes(childNode);
            } else if (childNode.getNodeType() == Node.TEXT_NODE) {
                String cdatameg = "<" + childNode.getNodeName() + "><![CDATA[" + childNode.getNodeValue() + "]]]]>><![CDATA[</" + childNode.getNodeName() + ">";
                String cdatamegRes = cdatameg.replaceAll("<#text>", "").replaceAll("</#text>", "");
                childNode.setTextContent(cdatamegRes);
            } else {

                String cdatameg = "<![CDATA[]]]]>><![CDATA[";
                childNode.setTextContent(cdatameg);

            }
        }*/

        String nodeStr = XmlUtil.toStr(returnNode);
        String[] nodeStrList = nodeStr.split("<");
        String a = "";
        for (String s : nodeStrList) {
            a = a + "<![CDATA[<" + s + "]]]]>>";
        }
        System.out.println(a);


    }

    public static void main(String[] args) {

        String aaaa = "<DATA>\n" +
                "                    <fp>\n" +
                "                        <Gfyhzh/>\n" +
                "                        <Kprq>2019-05-23</Kprq>\n" +
                "                        <Jshj>54.00</Jshj>\n" +
                "                        <Xfsh>92370100MA3EKX4426</Xfsh>\n" +
                "                        <Xfyhzh/>\n" +
                "                        <Gfdzdh/>\n" +
                "                        <Xfmc>高新开发区舜华惠嘉餐厅</Xfmc>\n" +
                "                        <Zfbz>N</Zfbz>\n" +
                "                        <Fphm>99424340</Fphm>\n" +
                "                        <Jqbm>661720186729</Jqbm>\n" +
                "                        <Fpdm>037001700107</Fpdm>\n" +
                "                        <Hcbz>N</Hcbz>\n" +
                "                        <Se>1.57</Se>\n" +
                "                        <Gfmc>个人</Gfmc>\n" +
                "                        <Gfsh/>\n" +
                "                        <Fplx>11</Fplx>\n" +
                "                        <Bz/>\n" +
                "                        <Je>52.43</Je>\n" +
                "                        <Jym>781948</Jym>\n" +
                "                        <Xfdzdh/>\n" +
                "                        <Sph>\n" +
                "                            <Xh>1</Xh>\n" +
                "                            <Ggxh/>\n" +
                "                            <Se>1.57</Se>\n" +
                "                            <Taxcode>3070401000000000000</Taxcode>\n" +
                "                            <Spmc>*餐饮服务*餐费</Spmc>\n" +
                "                            <Dj/>\n" +
                "                            <Jldw/>\n" +
                "                            <Sl/>\n" +
                "                            <Je>52.43</Je>\n" +
                "                            <Slv>3%</Slv>\n" +
                "                        </Sph>\n" +
                "                    </fp>\n" +
                "                    <result>\n" +
                "                        <code>1</code>\n" +
                "                        <message>查验成功</message>\n" +
                "                    </result>\n" +
                "                </DATA>";

        String nodeStr = aaaa;
        String[] nodeStrList = nodeStr.split("</");
        String a = "";
        for (int i = 0; i < nodeStrList.length; i++) {

                a = a + "<![CDATA[</" + nodeStrList[i]  + "]]]]>>";

        }
        /*String[] aRs = a.split("]]]]");
        String b = "";
        for (String aR : aRs) {
            b = b  + "<![CDATA[" + aR + "]]]]";
        }*/
        System.out.println(a);
    }


    @Override
    public boolean handleFault(SOAPMessageContext context) {
        return false;
    }

    @Override
    public void close(MessageContext context) {

    }
}
